package menuPackage;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.LinkedList;

import java.awt.Color;
import java.awt.Font;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;


/**
 * This class holds the JPanel to add a new item to the menu. 
 * Press enter after each textfield to set it. 
 * @author Pradnya
 *
 */

public class AddPanel extends JPanel{
	private JTextField NameField,DescField,PriceField, IngredientsField, FoodTypeField, AddMenuError;
	private JLabel Name,Desc,Price, Ingredients, FoodType;
	
	//n, d, i, f and p are where the values the user enters into the text fields will be stored
	private String n,d,i,f;
	private double p;
	private Gui gui;
	private JButton Add,Back;
	private JFrame frame;
	LinkedList<MenuItem> menu;
	LinkedList<MenuItem> foodType;
    MenuItem myMenuItem = new MenuItem();	
	MenuItem myfoodType = new MenuItem();
	ArrayList<String> FoodTypeList = new ArrayList<String>();
	private String itemName;
	ResultSet rsFoodItemsList;
	Color color = new Color(255,0,0); 
	Font font = new Font("Verdana", Font.BOLD, 12);
	
	private JComboBox box;	
	private static String[] filename = {"Select One", "Burgers", "Beverages", "Wings", "Wraps", "Sandwiches", "Flatbreads",
		"Appetizers", "Salads", "Combos", "Sides"};
	// private String[] filename = new String[FoodTypeList.size()];
	 
	private JComboBox IngredBox;
	// private JLabel picture;
	// Stores the file name
	
	private static String[] ingredientList = {"Select One", "Tomato", "Sugar", "Onions", "Hot Sauce",
			"Chicken", "Beef", "Peppers", "Bread"};
		
	private JList colorlist, copylist;
	private JButton copyButton;
	private final String[] colorNames = {"Select One", "Tomato", "Sugar", "Onions", "Hot Sauce",
				"Chicken", "Beef", "Peppers", "Bread"};
		
	public AddPanel(JFrame frame,LinkedList<MenuItem> menu){
		this.frame = frame;
		this.menu = menu;
		gui = new Gui();
		
		// Container container = getContentPane(frame, menu);
		
		
		colorlist = new JList (colorNames);
		colorlist.setVisibleRowCount(5);
		colorlist.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		//container.add(new JScrollPane(colorlist));

		// Set up TextFields
		TextListener tlistener = new TextListener();
		
		// Set create the JLabel
		Name = new JLabel("Name:");
		NameField = new JTextField(45);
		
		// Add ActionListener
		NameField.addActionListener(tlistener);
		
		// Repeat for the other two TextFields
		Desc = new JLabel("Description:");
		DescField = new JTextField(42);
		DescField.setText("Enter Description Here");
		DescField.addActionListener(tlistener);

		Price = new JLabel("Price: $");
		PriceField = new JTextField(5);
		PriceField.addActionListener(tlistener);
		
		Ingredients = new JLabel("Ingredients:");
		IngredientsField = new JTextField(100);
		
		// IngredientsField.setText("Enter Ingredients Here");
		// IngredientsField.addActionListener(tlistener);
		
		FoodType = new JLabel("Food Type:");
		FoodTypeField = new JTextField(100);
		
		AddMenuError = new JTextField(40);
		AddMenuError.addActionListener(tlistener);
		
		// FoodTypeField.setText("Enter Food Type Here");
		// FoodTypeField.addActionListener(tlistener);
		
        setLayout(new FlowLayout());
        // setLayout(new GridLayout(5,5));
       
        // Displays error if User does not fill out all the textfields/selects food type and ingredient(s)
        AddMenuError.setVisible(false);
        
        IngredBox = new JComboBox(ingredientList);
		// adding an item listener to the box
		// Takes an event handler object as the parameter
        IngredBox.addItemListener(
			// anonymous function that implements and itemlistener class
			new ItemListener(){ // anonymous class
				public void itemStateChanged(ItemEvent event){
					AddMenuError.setVisible(false);
					
					if (event.getStateChange() == ItemEvent.SELECTED)
						i = ingredientList[IngredBox.getSelectedIndex()];
						System.out.println("Ingredient :"+ingredientList[IngredBox.getSelectedIndex()]);
						// method in itemlistener
				}
					/*	if(event.getStateChange()==ItemEvent.SELECTED)
							picture.setIcon(pics[box.getSelectedIndex()]);*/
			});
		
		
		box = new JComboBox(filename);
		box.addItemListener(
			new ItemListener(){ // anonymous class
			
				public void itemStateChanged(ItemEvent event){
					AddMenuError.setVisible(false);
					
					if (event.getStateChange() == ItemEvent.SELECTED)
						f = filename[box.getSelectedIndex()];
						System.out.println("FoodType :"+filename[box.getSelectedIndex()]);
						
				}
						/*	if(event.getStateChange()==ItemEvent.SELECTED)
								picture.setIcon(pics[box.getSelectedIndex()]);*/
				});
			
		//Button setup		
						
		Add = new JButton("Add item");
		Add.addActionListener(new ButtonListener(this));
		Back = new JButton("Back");
		Back.addActionListener(new ButtonListener(this));
		
		p=0;
		
		// Displays buttons on the panel
		add(Name);
		add(NameField);
		add(Desc);
		add(DescField);
		add(Price);
		add(PriceField);
		add(FoodType);
		add(box);
		add(Ingredients);
		//	add(IngredientsField);
		add(IngredBox);
		//add(colorlist); 
	//	add(gui);
		
		add(Add);
		add(Back);
		add(AddMenuError);
	}
	
	private Container getContentPane(JFrame frame2, LinkedList<MenuItem> menu2) {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * ActionListener for TextFields. Similar to the the listener in MainMenuPanel.java
	 * Note that all TextFields take in a string so for the price you have to convert it
	 * to a double. Thats what the parseDouble() does.
	 *
	 */
	
	private class TextListener implements ActionListener {
		public void actionPerformed (ActionEvent event){
			if (event.getSource()==NameField)
				n=NameField.getText();
			else if(event.getSource()==DescField)
				d=DescField.getText();
			else if(event.getSource()==IngredientsField)
				i=IngredientsField.getText();
			//else if(event.getSource()==FoodTypeField)
			//	f = filename[box.getSelectedIndex()];
				//f=FoodTypeField.getText();
			else if (event.getSource()==IngredBox)
				i = ingredientList[0];
			else if (event.getSource()==box)
				f = filename[0];
			else
				p=Double.parseDouble(PriceField.getText());
		}
	}
	
	private class ButtonListener implements ActionListener{
		AddPanel panel;
		public ButtonListener(AddPanel p){
			this.panel=p;
			
			/* if you have dropdownlist named as ddlMenuIngredients
			
			   ArrayList<String> MenuIngredientsList = new ArrayList<String>(); 
			   clsDataAccess myDataAccess = new clsDataAccess();
			   MenuIngredientsList = myDataAccess.getIngredientList();
			   for (int i = 0; i < MenuIngredientsList.length; i++)
			   ddlMenuIngredients.addItem(MenuIngredientsList(i));
			   
			*/
			
		}
		/**
		 * If you hit the add button, it checks to make sure sure that all fields were entered.
		 * The item wont be added until all fields were set. 
		 */
		public void actionPerformed (ActionEvent event){
			if(event.getSource()==Add){
				//ResultSet resultSet = null;
				//int menuItemID = 400; 
				revalidate();
				repaint();
				updateUI();
				int menuItemID = 0;
				clsDataAccess myDataAccess = new clsDataAccess();
				if(n!=null && d!=null && p!=0 && box.getSelectedIndex() > 0 && IngredBox.getSelectedIndex() > 0){
					
					menuItemID = myDataAccess.getMaxMenuID(f);
				//	menuItemID = myDataAccess.getMaxMenuID("Burgers");
					System.out.println(menuItemID);
					menuItemID = menuItemID + 1; 
					
						

				//	myDataAccess.setMenuItems(300, "Test Menu3", "Test Menu3", "Test Menu3", 11.50);
					//dataAccess = new clsDataAccess();
				/*	resultSet = myDataAccess.getMaxMenuID("Burgers");
					try {
						menuItemID = resultSet.getInt("maxItemFoodID");
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					menuItemID = menuItemID + 1; 
					myDataAccess.getIngredientList();	*/
					
					//myDataAccess.setMenuItems(menuItemID, n, "test4", d, p); 
					//menuItemID = menuItemID + 1; 
				//	myDataAccess.setMenuItems(menuItemID, n, f, d, p); 
					String url = "www.google.com/search?q="+n;
					myDataAccess.setMenuItems(menuItemID, n, f, d, p, i, url); 
					//String url = "www.google.com";
				//	String url = "www.google.com/search?q="+n;
					System.out.println("Added item:");
					AddMenuError.setVisible(true);
					//Color color=new Color(255,0,0); 
					AddMenuError.setForeground(Color.blue);
				//	 Font font = new Font("Verdana", Font.BOLD, 12);
					 AddMenuError.setFont(font);
					 AddMenuError.setText("Menu Item added for: " +n);
					 AddMenuError.setEditable(false);
					myMenuItem.printItem(n,d,p,f, i, url,menuItemID);
					//System.out.println("Name: "+n);
					//System.out.println("Desc: "+d);
					//System.out.println("Price: "+p);
					//System.out.println("URL: "+url);
					//System.out.println("Menu ID: " +menuItemID);
					
					menu.add(new MenuItem(n,d,p,f, i));
				}
				
				else {
					AddMenuError.setVisible(true);
				    AddMenuError.setForeground(Color.red);
					AddMenuError.setFont(font);
					AddMenuError.setText("Please make sure all fields are entered.");
					AddMenuError.setEditable(false);
				}
					
				
			}
			
			else {
				revalidate();
				repaint();
				updateUI();
				frame.getContentPane().remove(panel);
				frame.getContentPane().add(new MainMenuPanel(frame,menu));
				frame.pack();
				frame.setVisible(true);
			}
		}
	}

	
	
	
}