package menuPackage;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import menuPackage.MainMenuPanel.ButtonListener;

/**
 * This is a sub-panel of the ViewMenuPanel. It represents an individual item. This panel will
 * be in an array of panels in the ViewMenuPanel for each item on the menu. This panel has a
 * Label for the name and options to edit and delete the item from the menu.
 * @author zac
 *
 */
public class EditMenuItemPanel extends JPanel{
	private JLabel Name;
	private JButton Edit,Remove;
	MenuItem item;
	private JFrame frame;
	LinkedList<MenuItem> menu;

	public EditMenuItemPanel(MenuItem item){
		this.item=item;
		
		Name = new JLabel(item.getName());
		Edit = new JButton("Edit");
		Remove = new JButton("Remove");
		
		Edit.addActionListener(new ButtonListener(this));
		Remove.addActionListener(new ButtonListener(this));
		
		
		add(Name);
		add(Edit);
		add(Remove);
		
	}
	
	/**
	 * This class waits for a user to click a button. All ActionListeners
	 * must have a method called actionPerformed. This is what the program will do
	 * when a button or something is pushed. 
	 * @author zac
	 *
	 */
	private class ButtonListener implements ActionListener{
		EditMenuItemPanel m;
		public ButtonListener(EditMenuItemPanel m){
			this.m = m;
		}
		/**
		 * the method checks to see which button was selected. That is what the 
		 * three different if statements do. ActionEvent is a class describing
		 * literally an event. this method checks the source of the event and
		 * depending on which button was pressed will do different things.
		 */
		public void actionPerformed (ActionEvent event){
			 if(event.getSource()==Edit){
				 revalidate();
					repaint();
					updateUI();
				MenuItem cur;
				//This loop just prints each items information to the console
				//it doesnt have anything to do with the interface
				for(int i=0;i<menu.size();i++){
					cur=menu.get(i);
					cur.printItem();
				}
				
				//Removes the main menu screen from the window
				frame.getContentPane().remove(m);
					
				//Sets the window to now show the ViewMenu Interface
				//Read the ViewMenuPanel code before reading the EditMenuItemPanel code
				frame.getContentPane().add(new ViewMenuPanel(frame,menu));
				
				//Always Required
				frame.pack();
				frame.setVisible(true);
				
			}
			 else if(event.getSource()==Remove){
				String itemName = item.getName();
				int result = 0;
				clsDataAccess myDataAccess = new clsDataAccess();
				//myDataAccess.removeMenuItems("test432");
				result = myDataAccess.removeMenuItems(itemName);
				
				if (result > 0){
				System.out.println(itemName +" Item Successfully Removed");
				//System.out.println("Item Successfully Removed");
				System.out.println("Remove");
				revalidate();
				repaint();
				updateUI();
				}
			}
		}
	}
	}


