package menuPackage;

import java.util.LinkedList;
import javax.swing.JFrame;

/**
 * This is the main class of the program. Most of the code here is to open a new window
 * for the GUI. Thats what the JFrame does. The frame is the actual window created
 * and any Panel class I created is what is actually inside the frame
 * 
 * The JFrame creates an instance of the MainMenuPanel class
 * @author zac
 *
 */

public class ManageMenuMain {
	public static void main(String[] args) {
		//Instantiate the menu
		//Using a LinkedList for now cuz the size of the menu is dynamic
		LinkedList<MenuItem> menu = new LinkedList<MenuItem>();
		//menu.add(new MenuItem("Food","Good",1));
		
		//Create a new frame
		JFrame frame = new JFrame("Manage Menu");
		
		//Ends program when user clicks the x button to close window
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		//sets when in the window to be the main menu screen
		frame.getContentPane().add(new MainMenuPanel(frame,menu));
		
		//these two lines are always required when making a GUI
		frame.pack();
		frame.setVisible(true);
		
	}
}

