package menuPackage;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;


/**
 * ViewMenuPanel is the window for viewing the entire menu. Right now it is really simple and prints
 * every item on the menu. Eventually we want a dropdown menu to select which category to view first
 * and then only print items from that category. 
 * 
 * This class is more complex and has nested JPanels. EditMenuItemPanel represents an individual item.
 * What it will have is the name of item with options to edit and delete buttons next to the name.
 * 
 * This class has an array of EditMenuItemPanels called panels. The size of this array, and therefore
 * the size of the window depends on the size of the menu. It will add a sub-panel to the overall window
 * for each item on the menu.
 * 
 * I havent done any of the implementation yet for this window but the layout is pretty much set up.
 * 
 * One other problem is that the buttons look really sloppy because the location of the buttons depends
 * on the length of the name. Try adding a menu item with a name one char long and then add on with a long
 * length and youll see what i mean.
 * @author zac
 *
 */
public class ViewMenuPanel extends JPanel{
	LinkedList<MenuItem> menu;
	EditMenuItemPanel[] panels;
	JPanel menulist;
	int size;
	private JButton Add,Back;
	private JFrame frame;
	public ViewMenuPanel(JFrame frame,LinkedList<MenuItem> menu){
		
		/*
		 * setLayout is used to determine how the window looks. 
		 * Normally the window keeps adding things to the right of the last component added.
		 * This is why the AddItem Screen is really long.
		 * Grid Layout sets the number of rows and columns of a window. 
		 * I dont exactly remember how I figured out the it needed (0,1) have to look into it
		 */
		setLayout(new GridLayout(0,1));
		
		this.frame=frame;
		this.menu=menu;
		size=menu.size();
		panels = new EditMenuItemPanel[size];
		menulist= new JPanel();

		for(int i=0;i<size;i++){
			panels[i]=new EditMenuItemPanel(menu.get(i));
			add(panels[i]);
		}
		Back = new JButton("Back");
		Back.addActionListener(new ButtonListener(this));

		add(Back);
	}
	
	private class ButtonListener implements ActionListener{
		ViewMenuPanel panel;
		public ButtonListener(ViewMenuPanel p){
			this.panel=p;
		}
		public void actionPerformed (ActionEvent event){
			revalidate();
			repaint();
			updateUI();
			frame.getContentPane().remove(panel);
			frame.getContentPane().add(new MainMenuPanel(frame,menu));
			frame.pack();
			frame.setVisible(true);
			
		}
	}
	
}
