
package menuPackage;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

/***
 * This class defines the connection string between the Application and the database. 
 * There are several methods contained here which give access to different queries to DB.
 * 
 * @author Pradnya
 *
 */

public class clsDataAccess {

	clsDataAccess() {}
	
	/* retrieves employee ID, first name, and last name of each 
	 * employee from database 
	 */
	
	public static void getEmployeeInfo()  {
		Connection conn = null;
		Statement statement = null;
		String driver = "com.mysql.jdbc.Driver";
		ResultSet resultSet = null;
				  
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();
			resultSet = statement.executeQuery("select employeeID, firstName, lastName from employeeinfo");
			writeResultSet(resultSet);
			conn.close();
			
			System.out.println("Close Connection");
		} 
		
		catch (SQLException e) 
		{	e.printStackTrace();	}
	}
		
	/* 
	 * 
	 */
	public static ArrayList<String> getIngredientList()  {
		Connection conn = null;
		Statement statement = null;
		String driver = "com.mysql.jdbc.Driver";
		ResultSet resultSet = null;
				  
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();
			ArrayList<String> MenuIngredientsList = new ArrayList<String>(); 
			resultSet = statement.executeQuery("SELECT * FROM ingredients;");
			while (resultSet.next()) {  
				       String MenuIngredient = resultSet.getString("ingredientname");      
				         MenuIngredientsList.add(MenuIngredient); } 
			//writeResultSet(resultSet);
			//conn.close();
			
			System.out.println("Close Connection");
			return MenuIngredientsList;
		} 
		
		catch (SQLException e) 
		{	e.printStackTrace();
			 return null;	}
			 
			 finally {
			if(conn != null) 
			{
				try {	conn.close();	} 
				catch (Exception e) { }
			}
		}
	}
	
	
//	public ArrayList<String> getMenuItemList()  {
		public ResultSet getMenuItemList()  {
		Connection conn = null;
		Statement statement = null;
		String driver = "com.mysql.jdbc.Driver";
		ResultSet resultSet = null;
				  
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();
			ArrayList<String> MenuItemList = new ArrayList<String>(); 
			resultSet = statement.executeQuery("SELECT * FROM menuitem;");
			
			/*while (resultSet.next()) {  
				       String MenuItem = resultSet.getString("itemName");      
			       MenuItemList.add(MenuItem); } */
			
			//writeResultSet(resultSet);
			//conn.close();
			
			System.out.println("Close Connection");
			//return MenuItemList;
			return resultSet;
			
		} 
		
		catch (SQLException e) 
		{	e.printStackTrace();
			 return null;	}
			 
		
		finally {
			if(conn != null) 
			{
				try {	conn.close();	} 
				catch (Exception e) { }
			}
		}
	}
		
		public ArrayList<String> getMenuItemArrayList()  {
		//	public ResultSet getMenuItemList()  {
	//	public String[] getMenuItemArrayList()  {
			Connection conn = null;
			Statement statement = null;
			String driver = "com.mysql.jdbc.Driver";
			ResultSet resultSet = null;
					  
			try 
			{
				conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
				System.out.println("Open Connection"); 
				statement = conn.createStatement();
				ArrayList<String> MenuItemList = new ArrayList<String>(); 
			//	String[] MenuItemList; 
				resultSet = statement.executeQuery("SELECT * FROM menuitem order by itemFoodType, itemName;");
				
				while (resultSet.next()) {  
					       String MenuItem = resultSet.getString("itemName");      
					//       MenuItemList.
				       MenuItemList.add(MenuItem); } 
				
				//writeResultSet(resultSet);
				//conn.close();
	
				System.out.println("Close Connection");
				return MenuItemList;
				//return resultSet;
				
			} 
			
			catch (SQLException e) 
			{	e.printStackTrace();
				 return null;	}
				 
			
			finally {
				if(conn != null) 
				{
					try {	conn.close();	} 
					catch (Exception e) { }
				}
			}
		}
		
		
		public ArrayList<String> getMenuItemArrayList(String itemFoodType)  {
			//	public ResultSet getMenuItemList()  {
		//	public String[] getMenuItemArrayList()  {
				Connection conn = null;
				Statement statement = null;
				String driver = "com.mysql.jdbc.Driver";
				ResultSet resultSet = null;
						  
				try 
				{
					conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
					System.out.println("Open Connection"); 
					statement = conn.createStatement();
					ArrayList<String> MenuItemList = new ArrayList<String>(); 
				//	String[] MenuItemList; 
					resultSet = statement.executeQuery("SELECT * FROM menuitem where itemfoodtype ='" + itemFoodType + "' order by itemName;");
					
					while (resultSet.next()) {  
						       String MenuItem = resultSet.getString("itemName");      
						//       MenuItemList.
					       MenuItemList.add(MenuItem); } 
					
					//writeResultSet(resultSet);
					//conn.close();
		
					System.out.println("Close Connection");
					return MenuItemList;
					//return resultSet;
					
				} 
				
				catch (SQLException e) 
				{	e.printStackTrace();
					 return null;	}
					 
				
				finally {
					if(conn != null) 
					{
						try {	conn.close();	} 
						catch (Exception e) { }
					}
				}
			}
	
	/* Generates a menu item ID for each item added to the database by User.
	 * User selects 'Food Type' and the system looks into the database, retrieves the max(itemID)
	 * and increments value by one. A count is set for each time a menu item is added successfully.
	 */
	
	public static int getMaxMenuID(String itemFoodType)  {
		Connection conn = null;
		Statement statement = null;
		//String driver = "com.mysql.jdbc.Driver";
		ResultSet resultSet = null;
		int maxItemFoodTypeID = 0;		  
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();
			resultSet = statement.executeQuery("SELECT max(itemid) AS MAX_ FROM menuitem where itemfoodtype ='" + itemFoodType + "';"); 
			while (resultSet.next()) {
			maxItemFoodTypeID = resultSet.getInt("MAX_");	
			System.out.println("Max MenuItemID = " +maxItemFoodTypeID);
		   }
			
			resultSet.close();
			statement.close();
		//	conn.close();
			System.out.println("Close Connection");
			return maxItemFoodTypeID;
		} 
		
		catch (SQLException e) 
		{	e.printStackTrace();
		    return 0;
		}
		finally {
			if(conn != null) 
			{
				try {	conn.close();	} 
				catch (Exception e) { }
			}
		}
	}
	
	
	public ResultSet getMenuItembyItemName(String itemName)  {
		Connection conn = null;
		Statement statement = null;
		//String driver = "com.mysql.jdbc.Driver";
		ResultSet resultSet = null;
		
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();
			resultSet = statement.executeQuery("SELECT * FROM menuitem where itemName ='" + itemName + "';"); 
					
		//	resultSet.close();
		//	statement.close();
		//	conn.close();
			System.out.println("Close Connection");
			return resultSet;
		} 
		
		catch (SQLException e) 
		{	e.printStackTrace();
		    return null;
		}
		/*finally {
			if(conn != null) 
			{
				try {	conn.close();	} 
				catch (Exception e) { }
			}
		}*/
	}
	
     // String[] getMenuItemInfo(String itemName)  {
   public ArrayList<String> getMenuItemInfo(String itemName)  {
		//	public ResultSet getMenuItemList()  {
	//	public String[] getMenuItemArrayList()  {
			Connection conn = null;
			Statement statement = null;
			String driver = "com.mysql.jdbc.Driver";
			ResultSet resultSet = null;
					  
			try 
			{
				conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
				System.out.println("Open Connection"); 
				statement = conn.createStatement();
				ArrayList<String> MenuItemInfo = new ArrayList<String>(); 
				resultSet = statement.executeQuery("SELECT * FROM menuitem where itemName ='" + itemName + "';");
							
				int columnCount = resultSet.getMetaData().getColumnCount();
				System.out.println("Column Count = "+columnCount);
				while (resultSet.next())
				{for (int i = 1; i <columnCount + 1 ; i++)
				{
					MenuItemInfo.add( resultSet.getString(i ) );
				}
				}
				
		/*		while (resultSet.next()) {  
				//	for (int i = 0; i < 6; i++ ){
					
					       MenuItems[1] = resultSet.getString("itemID").toString();   
					       MenuItems[2] = resultSet.getString("itemName");  
					       MenuItems[3] = resultSet.getString("itemFoodType");  
					       MenuItems[4] = resultSet.getString("itemDescription");  
					       MenuItems[5] = resultSet.getString("itemPrice");  
					       MenuItems[6] = resultSet.getString("URL");  
					       MenuItems[7] = resultSet.getString("ingredientName");  
					       
					//       MenuItemList.
					       for (int i = 1; i < 7; i++ ){
				       MenuItemInfo.add(MenuItems[i]);}
				  //     MenuItems =	MenuItemInfo.toArray(MenuItems);} 
				
				//writeResultSet(resultSet);
				conn.close();
				}
				
				*/
				
				System.out.println("Close Connection");
				return MenuItemInfo;
				//return resultSet;
				
		} 
			
			catch (SQLException e) 
			{	e.printStackTrace();
				 return null;	}
				 
			
			finally {
				if(conn != null) 
				{
					try {	conn.close();	} 
					catch (Exception e) { }
				}
			}
		}
	
	/* User enters in item name, item food type, item description, item price. 
	 * System will connect to the database and successfully add the desired item(s)
	 * It will place the item appropriately in the database based on the item ID generated from the
	 * above method
	 */
	public void setMenuItems(int itemID, String itemName, String itemFoodType, String itemDesc, double itemPrice)  {
		
		Connection conn = null;
		Statement statement = null;
		String driver = "com.mysql.jdbc.Driver";
		
		/*
		int intItemId = 100;
		String strItemName = "Test Menu";
		String strItemFoodType = "Test Food Type"; 
		String strItemDescription = "Test Menu Description";
		double dblPrice = 10.50;				  
		*/
		
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();	
			
			//statement.executeUpdate ("INSERT INTO MenuItem (itemID, itemName, itemFoodType, itemDescription, itemPrice)" +
			//                         "VALUES (100, 'Test Menu', 'Test Food Type', 'Test Menu Description', '10.50')"); 
					  				 
			  
			statement.executeUpdate("INSERT INTO MenuItem (itemID, itemName, itemFoodType, itemDescription, itemPrice) "+  
					                "VALUES ('"+itemID+"', '"+itemName+"','"+itemFoodType+"', '"+itemDesc+"','"+itemPrice+"')");
			  
		} 
		catch (SQLException e) 
		{	e.printStackTrace();	}
			  
		finally {
					if(conn != null) 
					{
						try {	conn.close();	} 
						catch (Exception e) { }
					}
			   }
	}
	
public void setMenuItems(int itemID, String itemName, String itemFoodType, String itemDesc, double itemPrice, String ingredient, String URL)  {
		
		Connection conn = null;
		Statement statement = null;
		String driver = "com.mysql.jdbc.Driver";
		
		/*
		int intItemId = 100;
		String strItemName = "Test Menu";
		String strItemFoodType = "Test Food Type"; 
		String strItemDescription = "Test Menu Description";
		double dblPrice = 10.50;				  
		*/
		
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();	
			
			//statement.executeUpdate ("INSERT INTO MenuItem (itemID, itemName, itemFoodType, itemDescription, itemPrice)" +
			//                         "VALUES (100, 'Test Menu', 'Test Food Type', 'Test Menu Description', '10.50')"); 
					  				 
			  
			statement.executeUpdate("INSERT INTO MenuItem (itemID, itemName, itemFoodType, itemDescription, itemPrice, ingredientName, URL) "+  
					                "VALUES ('"+itemID+"', '"+itemName+"','"+itemFoodType+"', '"+itemDesc+"','"+itemPrice+"', '"+ingredient+"', '"+URL+"')");
			  
		} 
		catch (SQLException e) 
		{	e.printStackTrace();	}
			  
		finally {
					if(conn != null) 
					{
						try {	conn.close();	} 
						catch (Exception e) { }
					}
			   }
	}
	

public void UpdateMenuItems(int itemID, String itemName, String itemFoodType, String itemDesc, double itemPrice, String ingredient, String URL)  {
	
	Connection conn = null;
	Statement statement = null;
	String driver = "com.mysql.jdbc.Driver";
	
	/*
	int intItemId = 100;
	String strItemName = "Test Menu";
	String strItemFoodType = "Test Food Type"; 
	String strItemDescription = "Test Menu Description";
	double dblPrice = 10.50;				  
	*/
	
	try 
	{
		conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
		System.out.println("Open Connection"); 
		statement = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);	
		
		//statement.executeUpdate ("INSERT INTO MenuItem (itemID, itemName, itemFoodType, itemDescription, itemPrice)" +
		//                         "VALUES (100, 'Test Menu', 'Test Food Type', 'Test Menu Description', '10.50')"); 
				  				 
		  
	/*	statement.executeUpdate("INSERT INTO MenuItem (itemID, itemName, itemFoodType, itemDescription, itemPrice, ingredientName, URL) "+  
				                "VALUES ('"+itemID+"', '"+itemName+"','"+itemFoodType+"', '"+itemDesc+"','"+itemPrice+"', '"+ingredient+"', '"+URL+"')");
	*/	
	/*	statement.executeUpdate("update MenuItem " +
								"Set itemName = '"+itemName+"'" +
								", itemFoodType = '" +itemFoodType+"'"+
				 				", itemDescription = '" +itemDesc+"'"+
								", itemPrice = '"+itemPrice+"'" +
								", ingredientName = '" +ingredient+"'"+
								", URL = '" +URL+"'"+
								" where itemID =" +itemID );*/
		
		statement.executeUpdate("update MenuItem SET itemName =  '"+itemName+"', " +
								" itemFoodType =  '"+itemFoodType+"', " +
								" itemDescription =  '"+itemDesc+"', " +
								" itemPrice =  '"+itemPrice+"', " +
								" ingredientName =  '"+ingredient+"', " +
								" URL =  '"+URL+"' " +
								" where itemID =  "+itemID );

				
		
	} 
	catch (SQLException e) 
	{	e.printStackTrace();	}
		  
	finally {
				if(conn != null) 
				{
					try {	conn.close();	} 
					catch (Exception e) { }
				}
		   }
}
	


	/* Retrieves desired menu item from database.
	 * Error will be display if item is not contained in the database  
	 * 
	 */
	public static int removeMenuItems(String itemName)  {
		
		Connection conn = null;
		Statement statement = null;
					
		try 
		{
			conn = DriverManager.getConnection(clsMySQLConnection.getConnectionString());
			System.out.println("Open Connection"); 
			statement = conn.createStatement();	
			
			//statement.executeUpdate ("INSERT INTO MenuItem (itemID, itemName, itemFoodType, itemDescription, itemPrice)" +
			//                         "VALUES (100, 'Test Menu', 'Test Food Type', 'Test Menu Description', '10.50')"); 
			ResultSet resultSet = null;	  				 
			resultSet = statement.executeQuery("Select itemName FROM menuitem where itemName ='" + itemName + "';"); 
			
			int rowCount = 0;
			
			while (resultSet.next())
			{	rowCount++;	}
			
			if (rowCount > 0){
				int result = statement.executeUpdate("Delete FROM menuitem where itemName ='" + itemName + "';"); 
				return result;  
			}
			
			else {
				System.out.println(itemName +" not found in the database");				
				return 0;
			}
		}
		
		catch (SQLException e) 
		{	e.printStackTrace();
		     return 0;
		}
			  
		finally {
			if(conn != null) {
				try {	conn.close();	} 
				catch (Exception e) { }
			}
		}
	}
		 
	public static void writeResultSet(ResultSet resultSet) throws SQLException {
	// ResultSet is initially before the first data set
		while (resultSet.next()) {
			// It is possible to get the columns via name
			// also possible to get the columns via the column number
			// which starts at 1
			// e.g. resultSet.getSTring(2);
			
			String employeeID = resultSet.getString("employeeID");
			String firstName = resultSet.getString("firstName");
			String lastName = resultSet.getString("lastName");
			// Date date = resultSet.getDate("datum");
			// String comment = resultSet.getString("comments");
			System.out.println("Employee ID: " + employeeID);
			System.out.println("First Name: " + firstName);
			System.out.println("Last Name: " + lastName);
			// System.out.println("Date: " + date);
			// System.out.println("Comment: " + comment);
		}
	}
		
	
   	             
	/* This is the main method call to get connection to restauto database. 
	 * Appropriate database name, username and password shall be inputed 
	 * in order to connect succesfully 
	 */
	public static String getConnectionString() throws SQLException {
		try
		{	
			String strConnectionString;
			String url = "jdbc:mysql://localhost:3306/";
			String dbName = "restauto";
			String driver = "com.mysql.jdbc.Driver";
			String userName = "root"; 
			String password = "pradnya";
			strConnectionString = url+dbName +"," + userName +"," + password; 	
			
			return (strConnectionString); 
       	}
		
		catch(java.lang.NullPointerException exp2)
		{	exp2.printStackTrace();
		  	return "test";                
		}
		
        catch (Exception e) 
        {  e.printStackTrace();
           return "test";
        }
	}
   
}